#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileio.h"

/*

This code is copyright 2004 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

/* BMP */

void write_bmp(FILE *out, unsigned int *picture, int width, int height)
{
int image_width,padding;
int x,y,ptr;

  image_width=width*3;
  while ((image_width%4)!=0) image_width++;

  padding=(width*3)%4;
  if (padding==0) padding=4;

/* size: 14 bytes */

  putc('B',out);
  putc('M',out);
  write_long(out,0);
  write_word(out,0);
  write_word(out,0);
  write_long(out,54);
/* head1: 14  head2: 40 */

  write_long(out,40);         /* biSize */
  write_long(out,width);
  write_long(out,height);
  write_word(out,1);
  write_word(out,24);
  write_long(out,0);          /* compression */
  write_long(out,image_width*height);
  write_long(out,0);          /* biXPelsperMetre */
  write_long(out,0);          /* biYPelsperMetre */
  write_long(out,0);
  write_long(out,0);

  for (y=height-1; y>=0; y--)
  {
    for (x=0; x<width; x++)
    {
      ptr=(y*width)+x;

/* printf("%d: 0x%06x\n",ptr,picture[ptr]); */

      putc(picture[ptr]&255,out);
      putc((picture[ptr]>>8)&255,out);
      putc((picture[ptr]>>16)&255,out);
    }

    for (x=padding; x<4; x++) putc(0,out);
  }
}



