#include <stdio.h>
#include <stdlib.h>

int bin2int(char *token)
{
int t,c,l;

  c=0;
  l=strlen(token);

  for (t=0; t<l; t++)
  {
    if (token[t]=='0') c=c*2;
      else
    if (token[t]=='1') c=(c*2)+1;
  }

  return c;
}

int get_token(FILE *in, char *token)
{
int ptr,ch;
int mode;

  ptr=0;
  mode=0;

  while(1)
  {
    ch=getc(in);

    if (mode==1)
    {
      if ((ch>='0' && ch <='9') || (ch>='A' && ch<='Z'))
      {
        token[ptr++]=ch;
      }
        else
      {
        ungetc(ch,in);
        break;
      }

    }
      else
    {
      if (ch==EOF) return -1;
      if ((ch>='0' && ch <='9') || (ch>='A' && ch<='Z'))
      {
        token[ptr++]=ch;
        mode=1;
      }
    }
  }

  token[ptr]=0;

  return 0;
}

int main()
{
FILE *out,*in;
int r,t,b,rev_code;
char token[1024];
int huffman_white_len[1024];
int huffman_black_len[1024];
int huffman_white_code[1024];
int huffman_black_code[1024];
int huffman_white_value[1024];
int huffman_black_value[1024];
int black_ptr;
int white_ptr;

  out=fopen("huffman_tables.h","wb");
  if (out==0)
  {
    exit(1);
  }

  in=fopen("huffman_codes.txt","rb");
  if (in==0)
  {
    fclose(out);
    exit(1);
  }

  while(1)
  {
    if (get_token(in,token)==-1) break;
    if (strcmp(token,"EOL")==0)
    { huffman_white_value[white_ptr]=-1; }
      else
    { huffman_white_value[white_ptr]=atoi(token); }

    if (get_token(in,token)==-1) break;
    huffman_white_len[white_ptr]=strlen(token);
    huffman_white_code[white_ptr]=bin2int(token);

    if (get_token(in,token)==-1) break;
    if (strcmp(token,"EOL")==0)
    { huffman_black_value[black_ptr]=-1; }
      else
    { huffman_black_value[black_ptr]=atoi(token); }

    if (get_token(in,token)==-1) break;
    huffman_black_len[black_ptr]=strlen(token);
    huffman_black_code[black_ptr]=bin2int(token);

    white_ptr++;
    black_ptr++;
  }

  if (white_ptr!=black_ptr) printf("Uh oh.. white and black aren't equal\n");

  fprintf(out,"\n\nhuffman_white_code[%d] = {\n",white_ptr);
  for (t=0; t<white_ptr; t++)
  {
    fprintf(out,"%4d, ",huffman_white_code[t]);  
    if (((t+1)%10)==0) fprintf(out,"\n");
  }

  fprintf(out,"\n\nhuffman_white_len[%d] = {\n",white_ptr);
  for (t=0; t<white_ptr; t++)
  {
    fprintf(out,"%4d, ",huffman_white_len[t]);  
    if (((t+1)%10)==0) fprintf(out,"\n");
  }

  fprintf(out,"\n\nhuffman_white_value[%d] = {\n",white_ptr);
  for (t=0; t<white_ptr; t++)
  {
    fprintf(out,"%4d, ",huffman_white_value[t]);  
    if (((t+1)%10)==0) fprintf(out,"\n");
  }

  fprintf(out,"\n\nhuffman_black_code[%d] = {\n",black_ptr);
  for (t=0; t<black_ptr; t++)
  {
    fprintf(out,"%4d, ",huffman_black_code[t]);  
    if (((t+1)%10)==0) fprintf(out,"\n");
  }

  fprintf(out,"\n\nhuffman_black_len[%d] = {\n",black_ptr);
  for (t=0; t<black_ptr; t++)
  {
    fprintf(out,"%4d, ",huffman_black_len[t]);  
    if (((t+1)%10)==0) fprintf(out,"\n");
  }

  fprintf(out,"\n\nhuffman_black_value[%d] = {\n",black_ptr);
  for (t=0; t<black_ptr; t++)
  {
    fprintf(out,"%4d, ",huffman_black_value[t]);  
    if (((t+1)%10)==0) fprintf(out,"\n");
  }

  fclose (out);
  fclose (in);

  return 0;
}


