
/*

Tiff - Copyright 2005 Michael Kohn (mike@mikekohn.net)

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

struct tiff_info_t
{
  int y_offset;
  int width;
  int height;
  int endian;
  int compression;
  int bits_per_sample;
  int *color_map;
  int max_colors;
  int color_order;
  int strip_count;
  int strip_offset;
  int rows_per_strip; 
};

struct tiff_header_t
{
  char byte_order[2];
  int version;
  int pointer_to_ifd;
};

struct tiff_ifd_t
{
  int tag_type;
  int data_type;
  int length;
  int value;
};

unsigned int *read_tiff(FILE *in, int *width, int *height);

int read_ccitt_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info, int group);
int read_huffman_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info);
int read_packed_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info);
int read_uncomp_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info);



