#include <stdio.h>
#include <stdlib.h>

#include "fileio.h"
#include "huffman_tables.h"
#include "tiff.h"

/*

TIFF - Copyright 2005 Michael Kohn (mike@mikekohn.net)

This program is NOT opensourced.  You may not use any part
of this program for your own software.

*/

int read_ccitt_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info, int group)
{
int x,y,ptr,r,t=0;
int y_stop;
int holding,bitptr,blackwhite;
int ch;
int c,k=0;

  y_stop=tiff_info->y_offset+tiff_info->rows_per_strip;
  if (y_stop>=tiff_info->height) y_stop=tiff_info->height;

  holding=0;
  bitptr=0;

  for (y=tiff_info->y_offset; y<y_stop; y++)
  {
    blackwhite=1;
    x=0;

    if (group==3)
    {
      c=bitptr;

      while(c<12) c=c+8;
/*
      if ((bitptr%8)>=4)
      { c=12; }
        else
      { c=16; }
*/

#ifdef DEBUG
printf("bitptr=%d c=%d\n",bitptr,c);
#endif

      while (bitptr<c)
      {
        ch=getc(in);
        holding=(holding<<8)+ch;
        bitptr=bitptr+8;
      }

#ifdef DEBUG
printf("eating: %d\n",holding>>(bitptr-c));
#endif

      bitptr=bitptr-c;
      holding=holding&((1<<bitptr)-1);

      if (bitptr<8)
      {
        ch=getc(in);
        holding=(holding<<8)+ch;
        bitptr=bitptr+8;
      }

      k=holding>>(bitptr-1);
      bitptr=bitptr-1;
      holding=holding&((1<<bitptr)-1);

#ifdef DEBUG
printf("k=%d\n",k);
#endif
    }

    while (x<tiff_info->width)
    {
      ptr=x+(y*tiff_info->width);

      /* if ((group==3 && k==0) || group==4) */
      if (k==0)
      {
        for (t=0; t<11; t++)
        {
          while (ccitt_2d_len[t]>bitptr)
          {
            ch=getc(in);
            holding=(holding<<8)+ch;
            bitptr=bitptr+8;
          }

          if (ccitt_2d_code[t]==(holding>>(bitptr-ccitt_2d_len[t])))
          { break; }
        }

        if (t==11)
        {
          printf("Error: Uknown CCITT huffman code\n");
          return -1;
        }

#ifdef DEBUG
printf("CCITT code %d  / y=%d x=%d  ptr=%d\n",t,y,x,ptr);
#endif

        bitptr=bitptr-ccitt_2d_len[t];
        holding=holding&((1<<bitptr)-1);
      }

      if (k==1)
      { }
        else
      if (y==0)
      {
        if (t==0)
        {
#ifdef DEBUG
printf("PASSCODE\n");
#endif
          for (t=0; t<tiff_info->width-x; t++)
          { picture[ptr+t]=tiff_info->color_map[blackwhite]; }
          break;
        }
          else
        {
#ifdef DEBUG
if (t==2) printf("V(0)\n");
  else
if (t>=6 && t<=8) printf("Vl(%d)\n",3-(8-t));
  else
if (t>=3 && t<=5) printf("Vr(%d)\n",3-(5-t));
  else
if (t==1) printf("Horizontal\n");
  else
printf("unknown code\n");
#endif
          if (t==2)
          {
            for (r=0; r<tiff_info->width-x; r++)
            {
              picture[ptr+r]=tiff_info->color_map[blackwhite];
            }
            x=x+r;
            break;
          }
            else
          if (t>=6 && t<=8)
          {
            for (r=0; r<tiff_info->width-x-(t-5); r++)
            {
              picture[ptr+r]=tiff_info->color_map[blackwhite];
              x++;
            }
#ifdef DEBUG
printf("x=%d\n",x);
#endif
            blackwhite^=1;
            continue;
          }
            else
          if (t!=1)
          { printf("wtf? t=%d\n",t); }

        }
      }
        else
      {
        if (t==0)
        {
#ifdef DEBUG
printf("PASSCODE\n");
#endif
          r=0;
          for (t=0; t<tiff_info->width-x; t++)
          {
            if (r==0 && picture[ptr+t-tiff_info->width]!=tiff_info->color_map[blackwhite])
            { r=1; }
              else
            if (r==1 && picture[ptr+t-tiff_info->width]==tiff_info->color_map[blackwhite])
            { break; }

            picture[ptr+t]=tiff_info->color_map[blackwhite];
          }

          x=x+t;
          continue;
        }
          else
        if (t>=2 && t<=8)
        {
#ifdef DEBUG
if (t==2) printf("V(0)\n");
#endif
          for (r=0; r<tiff_info->width-x; r++)
          {
            if (picture[ptr+r-tiff_info->width]!=tiff_info->color_map[blackwhite])
            { break; }

            picture[ptr+r]=tiff_info->color_map[blackwhite];
          }
#ifdef DEBUG
printf("x=%d  blackwhite=%d\n",x,blackwhite);
#endif

          x=x+r;

/*
          if (t==2)
          { x=x+r; }
            else
*/
          if (t>=6 && t<=8)
          {
#ifdef DEBUG
printf("Vl(%d)\n",3-(8-t));
#endif
            /* x=x+r; */

            for (r=0; r<-ccitt_2d_value[t]; r++)
            {
              picture[ptr+x-r-1]=tiff_info->color_map[blackwhite^1];
            }
            /* x=x+r+ccitt_2d_value[t]; */
          }
            else
          if (t>=3 && t<=5)
          {
#ifdef DEBUG
printf("Vr(%d)\n",3-(5-t));
#endif
            /* x=x+r; */

printf("gonna adjusted x=%d  blackwhite=%d\n",x,blackwhite);
            ptr=ptr+r;

            for (r=0; r<ccitt_2d_value[t]; r++)
            { picture[ptr+r]=tiff_info->color_map[blackwhite]; }

            x=x+ccitt_2d_value[t];

printf("adjusted x=%d  blackwhite=%d\n",x,blackwhite);
          }

          blackwhite^=1;

          continue;
        }
          else
        if (t==9 || t==10)
        {
          printf("Error: Extension\n");
          return -2;
        }
      }

      for (c=0; c<2; c++)
      {
        if (blackwhite==1)
        {
          for (t=0; t<TOTAL_CODES; t++)
          {
            while (huffman_white_len[t]>bitptr)
            {
              ch=getc(in);
              holding=(holding<<8)+ch;
              bitptr=bitptr+8;
            }
/* printf("holding=%d bitptr=%d\n",holding,bitptr); */

            if (huffman_white_code[t]==(holding>>(bitptr-huffman_white_len[t])))
            { break; }
          }

          if (t==TOTAL_CODES)
          {
            printf("Illegal huffman code\n");
            return -1;
          }

          if (t==-1)
          { return 0; }

          bitptr=bitptr-huffman_white_len[t];
          holding=holding&((1<<bitptr)-1);

          t=huffman_white_value[t];
          for (r=0; r<t; r++) picture[ptr++]=tiff_info->color_map[blackwhite];
          x=x+t;
printf("%d whites\n",t);
        }
          else
        {
          for (t=0; t<TOTAL_CODES; t++)
          {
            while (huffman_black_len[t]>bitptr)
            {
              holding=(holding<<8)+getc(in);
              bitptr=bitptr+8;
            }

            if (huffman_black_code[t]==(holding>>(bitptr-huffman_black_len[t])))
            { break; }
          }

          if (t==TOTAL_CODES)
          {
            printf("Illegal huffman code\n");
            return -1;
          }

          if (t==-1)
          { return 0; }

          bitptr=bitptr-huffman_black_len[t];
          holding=holding&((1<<bitptr)-1);

          t=huffman_black_value[t];
          for (r=0; r<t; r++) picture[ptr++]=tiff_info->color_map[blackwhite];
          x=x+t;
printf("%d black\n",t);
        }

        if (x==tiff_info->width) break;

        if (t<64) blackwhite^=1;
          else
        { c--; }
      }
    }

    if (x!=tiff_info->width)
    {
      printf("Error: Run length codes under/overran width %d\n",x);
      // return -1;
    }

/*
if (group==3)
{
    if (bitptr>=24)
    {
      holding=holding&0xffffff;
      bitptr=24;
    }
      else
    if (bitptr>=16)
    {
      holding=holding&0xffff;
      bitptr=16;
    }
      else
    if (bitptr>=8)
    {
      holding=holding&0xff;
      bitptr=8;
    }
      else
    {
      holding=0;
      bitptr=0;
    }
}
*/
  }

  return 0;
}

int read_huffman_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info)
{
int x,y,ptr,r,t;
int y_stop;
int holding,bitptr,blackwhite;
int ch;

  y_stop=tiff_info->y_offset+tiff_info->rows_per_strip;
  if (y_stop>=tiff_info->height) y_stop=tiff_info->height;

  holding=0;
  bitptr=0;

  for (y=tiff_info->y_offset; y<y_stop; y++)
  {
    blackwhite=1;
    x=0;

    while (x<tiff_info->width)
    {
      ptr=x+(y*tiff_info->width);

      if (blackwhite==1)
      {
        for (t=0; t<TOTAL_CODES; t++)
        {
          while (huffman_white_len[t]>bitptr)
          {
            ch=getc(in);
            holding=(holding<<8)+ch;
            bitptr=bitptr+8;
          }
/* printf("holding=%d bitptr=%d\n",holding,bitptr); */

          if (huffman_white_code[t]==(holding>>(bitptr-huffman_white_len[t])))
          { break; }
        }

        if (t==TOTAL_CODES)
        {
          printf("Illegal huffman code\n");
          return -1;
        }

        if (t==-1)
        { return 0; }

        bitptr=bitptr-huffman_white_len[t];
        holding=holding&((1<<bitptr)-1);

        t=huffman_white_value[t];
        for (r=0; r<t; r++) picture[ptr++]=tiff_info->color_map[blackwhite];
        x=x+t;
/* printf("%d whites\n",t); */
      }
        else
      {
        for (t=0; t<TOTAL_CODES; t++)
        {
          while (huffman_black_len[t]>bitptr)
          {
            holding=(holding<<8)+getc(in);
            bitptr=bitptr+8;
          }

          if (huffman_black_code[t]==(holding>>(bitptr-huffman_black_len[t])))
          { break; }
        }

        if (t==TOTAL_CODES)
        {
          printf("Illegal huffman code\n");
          return -1;
        }

        if (t==-1)
        { return 0; }

        bitptr=bitptr-huffman_black_len[t];
        holding=holding&((1<<bitptr)-1);

        t=huffman_black_value[t];
        for (r=0; r<t; r++) picture[ptr++]=tiff_info->color_map[blackwhite];
        x=x+t;
/* printf("%d black\n",t); */
      }

      if (t<64) blackwhite^=1;
    }

    if (x!=tiff_info->width)
    {
      printf("Error: Run length codes overran width %d\n",x);
      return -1;
    }

    if (bitptr>=24)
    {
      holding=holding&0xffffff;
      bitptr=24;
    }
      else
    if (bitptr>=16)
    {
      holding=holding&0xffff;
      bitptr=16;
    }
      else
    if (bitptr>=8)
    {
      holding=holding&0xff;
      bitptr=8;
    }
      else
    {
      holding=0;
      bitptr=0;
    }
  }

  return 0;
}

int read_packed_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info)
{
int x,y,ptr,r;
int y_stop,curr_code,count;
int mode;

  y_stop=tiff_info->y_offset+tiff_info->rows_per_strip;
  if (y_stop>=tiff_info->height) y_stop=tiff_info->height;

  r=0; count=0;

  if (tiff_info->bits_per_sample==8)
  {
    for (y=tiff_info->y_offset; y<y_stop; y++)
    {
      curr_code=0;
      mode=0;

      for (x=0; x<tiff_info->width; x++)
      {
        if (mode==0)
        {
          curr_code=getc(in);

          if (curr_code==0x80)
          { continue; }
            else
          if (curr_code>=0x81)
          {
            mode=2;
            count=((curr_code^0xff)+1)+1;
            r=getc(in);
          }
            else
          {
            mode=1;
            count=curr_code+1;
          }
        }

        if (mode==1)
        { r=getc(in); }

        count--;
        if (count==0) mode=0;

        ptr=x+(y*tiff_info->width);
        picture[ptr]=tiff_info->color_map[r];
      }
    }
  }
    else
  {
    printf("Unknown uncompressed format.  Please inform mike@mikekohn.net about it.\n");
  }

  return 0;
}

int read_uncomp_tiff(FILE *in, unsigned int *picture, struct tiff_info_t *tiff_info)
{
int x,y,ptr,r,g,b;
int y_stop;

  y_stop=tiff_info->y_offset+tiff_info->rows_per_strip;
  if (y_stop>=tiff_info->height) y_stop=tiff_info->height;

  if (tiff_info->bits_per_sample==1)
  {
    for (y=tiff_info->y_offset; y<y_stop; y++)
    {
      x=0;
      while (x<tiff_info->width)
      {
        r=getc(in);

        ptr=x+(y*tiff_info->width);

        for (b=7; b>=0; b--)
        {
          if (((r>>b)&1)==0)
          { picture[ptr]=tiff_info->color_map[0]; }
            else
          { picture[ptr]=tiff_info->color_map[1]; }

          ptr++;
          x++;
          if (x>=tiff_info->width) break;
        }
      }
    }
  }
    else
  if (tiff_info->bits_per_sample==8)
  {
    for (y=tiff_info->y_offset; y<y_stop; y++)
    {
      for (x=0; x<tiff_info->width; x++)
      {
        r=getc(in);
        ptr=x+(y*tiff_info->width);
        picture[ptr]=tiff_info->color_map[r];
      }
    }
  }
    else
  if (tiff_info->bits_per_sample==24)
  {
    for (y=tiff_info->y_offset; y<y_stop; y++)
    {
      for (x=0; x<tiff_info->width; x++)
      {
        r=getc(in);
        g=getc(in);
        b=getc(in);
        ptr=x+(y*tiff_info->width);
        picture[ptr]=(r<<16)+(g<<8)+b;
      }
    }
  }
    else
  {
    printf("Unknown uncompressed format.  Please inform mike@mikekohn.net about it.\n");
  }

  return 0;
}


